"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const baseProj_1 = require("./baseProj");
const zip_i_1 = require("zip-i");
const fs_i_1 = require("fs-i");
const fs_extra_1 = require("fs-extra");
const path = require("path");
const globalData_1 = require("../model/globalData");
const ProjectType_1 = require("../model/ProjectType");
class MainProj extends baseProj_1.BaseProj {
    getQuestions() {
        let questionList = [
            {
                name: "projectName",
                type: "input",
                message: "请输入项目名称",
                default: "project1"
            },
            {
                name: "projectType",
                type: "list",
                message: "请选择项目类型",
                default: "node",
                choices: ["node", "webpack", "angular2"]
            }
        ];
        return questionList;
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            let answer = yield this.getAnswers();
            globalData_1.GlobalData.projectName = answer.projectName;
            globalData_1.GlobalData.projectType = ProjectType_1.newProjectType(answer.projectType);
            let targetPath = `${process.cwd()}/${answer.projectName}`;
            let templateZipFile = path.join(__dirname, "..", "template/node.zip");
            yield fs_i_1.mkdirs(targetPath);
            yield zip_i_1.unzipPath(templateZipFile, targetPath);
            yield this.replaceProjectName(targetPath, answer);
        });
    }
    replaceProjectName(path, answer) {
        return __awaiter(this, void 0, void 0, function* () {
            let files = yield fs_i_1.getAllFiles(path);
            for (let file of files) {
                let fileContent = yield fs_i_1.readFileUtf8(file);
                fileContent = fileContent.replace(/{{projectName}}/g, answer.projectName);
                fs_extra_1.writeFileSync(file, fileContent);
            }
        });
    }
}
exports.MainProj = MainProj;
//# sourceMappingURL=mainProj.js.map